package org.apache.lucene.index;

import java.io.PrintStream;
import java.lang.reflect.Field;
import java.util.Vector;

import org.apache.lucene.store.Directory;

public class IndexGate {
  static Field deletable = null;
  static PrintStream infoStream = IndexWriter.getDefaultInfoStream();
  
  static {
    try {
      deletable = IndexFileDeleter.class.getDeclaredField("deletable");
      deletable.setAccessible(true);
    } catch (Exception e) {
      e.printStackTrace();
    }
  }
  
  public static Vector getDeletableFiles(Directory dir) throws Exception {
    SegmentInfos infos = new SegmentInfos();
    infos.read(dir);
    IndexFileDeleter deleter = new IndexFileDeleter(dir, new KeepOnlyLastCommitDeletionPolicy(), infos, infoStream);
    return (Vector)deletable.get(deleter);
  }
  
  public static Vector getSegmentFiles(Directory dir) throws Exception {
    SegmentInfos infos = new SegmentInfos();
    infos.read(dir);
    Vector names = new Vector();
    for (int i = 0; i < infos.size(); i++) {
      names.add(infos.info(i).name);
    }
    return names;
  }
  

}
